tomcat-9.sh 6.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141
  1. #!/bin/bash
  2. # Author: yeho <lj2007331 AT gmail.com>
  3. # BLOG: https://linuxeye.com
  4. #
  5. # Notes: OneinStack for CentOS/RedHat 7+ Debian 9+ and Ubuntu 16+
  6. #
  7. # Project home page:
  8. # https://oneinstack.com
  9. # https://github.com/oneinstack/oneinstack
  10. Install_Tomcat9() {
  11. pushd ${oneinstack_dir}/src > /dev/null
  12. . /etc/profile
  13. id -g ${run_group} >/dev/null 2>&1
  14. [ $? -ne 0 ] && groupadd ${run_group}
  15. id -u ${run_user} >/dev/null 2>&1
  16. [ $? -ne 0 ] && useradd -g ${run_group} -M -s /bin/bash ${run_user} || { [ -z "$(grep ^${run_user} /etc/passwd | grep '/bin/bash')" ] && usermod -g ${run_group} -s /bin/bash ${run_user}; }
  17. # install apr
  18. if [ ! -e "${apr_install_dir}/bin/apr-1-config" ]; then
  19. tar xzf apr-${apr_ver}.tar.gz
  20. pushd apr-${apr_ver} > /dev/null
  21. ./configure --prefix=${apr_install_dir}
  22. make -j ${THREAD} && make install
  23. popd > /dev/null
  24. rm -rf apr-${apr_ver}
  25. fi
  26. tar xzf apache-tomcat-${tomcat9_ver}.tar.gz
  27. [ ! -d "${tomcat_install_dir}" ] && mkdir -p ${tomcat_install_dir}
  28. /bin/cp -R apache-tomcat-${tomcat9_ver}/* ${tomcat_install_dir}
  29. rm -rf ${tomcat_install_dir}/webapps/{docs,examples,host-manager,manager,ROOT/*}
  30. if [ ! -e "${tomcat_install_dir}/conf/server.xml" ]; then
  31. rm -rf ${tomcat_install_dir}
  32. echo "${CFAILURE}Tomcat install failed, Please contact the author! ${CEND}" && lsb_release -a
  33. kill -9 $$; exit 1;
  34. fi
  35. pushd ${tomcat_install_dir}/bin > /dev/null
  36. tar xzf tomcat-native.tar.gz
  37. pushd tomcat-native-*-src/native > /dev/null
  38. if [ "${armplatform}" == "y" ]; then
  39. ./configure --prefix=${apr_install_dir} --with-apr=${apr_install_dir}
  40. else
  41. ./configure --prefix=${apr_install_dir} --with-apr=${apr_install_dir} --with-ssl=${openssl_install_dir}
  42. fi
  43. make -j ${THREAD} && make install
  44. popd > /dev/null
  45. rm -rf tomcat-native-*
  46. if [ -e "${apr_install_dir}/lib/libtcnative-1.la" ]; then
  47. [ ${Mem} -le 768 ] && let Xms_Mem="${Mem}/3" || Xms_Mem=256
  48. let XmxMem="${Mem}/2"
  49. cat > ${tomcat_install_dir}/bin/setenv.sh << EOF
  50. JAVA_OPTS='-Djava.security.egd=file:/dev/./urandom -server -Xms${Xms_Mem}m -Xmx${XmxMem}m -Dfile.encoding=UTF-8'
  51. CATALINA_OPTS="-Djava.library.path=${apr_install_dir}/lib"
  52. # -Djava.rmi.server.hostname=$IPADDR
  53. # -Dcom.sun.management.jmxremote.password.file=\$CATALINA_BASE/conf/jmxremote.password
  54. # -Dcom.sun.management.jmxremote.access.file=\$CATALINA_BASE/conf/jmxremote.access
  55. # -Dcom.sun.management.jmxremote.ssl=false"
  56. EOF
  57. chmod +x ./*.sh
  58. /bin/mv ${tomcat_install_dir}/conf/server.xml{,_bk}
  59. popd # goto ${oneinstack_dir}/src
  60. /bin/cp ${oneinstack_dir}/config/server.xml ${tomcat_install_dir}/conf
  61. sed -i "s@/usr/local/tomcat@${tomcat_install_dir}@g" ${tomcat_install_dir}/conf/server.xml
  62. if [ ! -e "${nginx_install_dir}/sbin/nginx" -a ! -e "${tengine_install_dir}/sbin/nginx" -a ! -e "${openresty_install_dir}/nginx/sbin/nginx" -a ! -e "${apache_install_dir}/bin/httpd" ]; then
  63. if [ "${PM}" == 'yum' ]; then
  64. if [ -n "`grep 'dport 80 ' /etc/sysconfig/iptables`" ] && [ -z "$(grep -w '8080' /etc/sysconfig/iptables)" ]; then
  65. iptables -I INPUT 5 -p tcp -m state --state NEW -m tcp --dport 8080 -j ACCEPT
  66. service iptables save
  67. ip6tables -I INPUT 5 -p tcp -m state --state NEW -m tcp --dport 8080 -j ACCEPT
  68. service ip6tables save
  69. fi
  70. elif [ "${PM}" == 'apt-get' ]; then
  71. if [ -e '/etc/iptables/rules.v4' ]; then
  72. if [ -n "`grep 'dport 80 ' /etc/iptables/rules.v4`" ] && [ -z "$(grep -w '8080' /etc/iptables/rules.v4)" ]; then
  73. iptables -I INPUT 5 -p tcp -m state --state NEW -m tcp --dport 8080 -j ACCEPT
  74. iptables-save > /etc/iptables/rules.v4
  75. ip6tables -I INPUT 5 -p tcp -m state --state NEW -m tcp --dport 8080 -j ACCEPT
  76. ip6tables-save > /etc/iptables/rules.v6
  77. fi
  78. elif [ -e '/etc/iptables.up.rules' ]; then
  79. if [ -n "`grep 'dport 80 ' /etc/iptables.up.rules`" ] && [ -z "$(grep -w '8080' /etc/iptables.up.rules)" ]; then
  80. iptables -I INPUT 5 -p tcp -m state --state NEW -m tcp --dport 8080 -j ACCEPT
  81. iptables-save > /etc/iptables.up.rules
  82. fi
  83. fi
  84. fi
  85. fi
  86. [ ! -d "${tomcat_install_dir}/conf/vhost" ] && mkdir ${tomcat_install_dir}/conf/vhost
  87. cat > ${tomcat_install_dir}/conf/vhost/localhost.xml << EOF
  88. <Host name="localhost" appBase="${wwwroot_dir}/default" unpackWARs="true" autoDeploy="true">
  89. <Context path="" docBase="${wwwroot_dir}/default" reloadable="false" crossContext="true"/>
  90. <Valve className="org.apache.catalina.valves.AccessLogValve" directory="logs"
  91. prefix="localhost_access_log" suffix=".txt" pattern="%h %l %u %t &quot;%r&quot; %s %b" />
  92. <Valve className="org.apache.catalina.valves.RemoteIpValve" remoteIpHeader="X-Forwarded-For"
  93. protocolHeader="X-Forwarded-Proto" protocolHeaderHttpsValue="https"/>
  94. </Host>
  95. EOF
  96. # logrotate tomcat catalina.out
  97. cat > /etc/logrotate.d/tomcat << EOF
  98. ${tomcat_install_dir}/logs/catalina.out {
  99. daily
  100. rotate 5
  101. missingok
  102. dateext
  103. compress
  104. notifempty
  105. copytruncate
  106. }
  107. EOF
  108. [ -z "$(grep '<user username="admin" password=' ${tomcat_install_dir}/conf/tomcat-users.xml)" ] && sed -i "s@^</tomcat-users>@<role rolename=\"admin-gui\"/>\n<role rolename=\"admin-script\"/>\n<role rolename=\"manager-gui\"/>\n<role rolename=\"manager-script\"/>\n<user username=\"admin\" password=\"$(cat /dev/urandom | head -1 | md5sum | head -c 10)\" roles=\"admin-gui,admin-script,manager-gui,manager-script\"/>\n</tomcat-users>@" ${tomcat_install_dir}/conf/tomcat-users.xml
  109. cat > ${tomcat_install_dir}/conf/jmxremote.access << EOF
  110. monitorRole readonly
  111. controlRole readwrite \
  112. create javax.management.monitor.*,javax.management.timer.* \
  113. unregister
  114. EOF
  115. cat > ${tomcat_install_dir}/conf/jmxremote.password << EOF
  116. monitorRole $(cat /dev/urandom | head -1 | md5sum | head -c 8)
  117. # controlRole R&D
  118. EOF
  119. chown -R ${run_user}:${run_group} ${tomcat_install_dir}
  120. /bin/cp ${oneinstack_dir}/init.d/Tomcat-init /etc/init.d/tomcat
  121. sed -i "s@JAVA_HOME=.*@JAVA_HOME=${JAVA_HOME}@" /etc/init.d/tomcat
  122. sed -i "s@^CATALINA_HOME=.*@CATALINA_HOME=${tomcat_install_dir}@" /etc/init.d/tomcat
  123. sed -i "s@^TOMCAT_USER=.*@TOMCAT_USER=${run_user}@" /etc/init.d/tomcat
  124. [ "${PM}" == 'yum' ] && { chkconfig --add tomcat; chkconfig tomcat on; }
  125. [ "${PM}" == 'apt-get' ] && update-rc.d tomcat defaults
  126. echo "${CSUCCESS}Tomcat installed successfully! ${CEND}"
  127. rm -rf apache-tomcat-${tomcat9_ver}
  128. else
  129. popd > /dev/null
  130. echo "${CFAILURE}Tomcat install failed, Please contact the author! ${CEND}" && lsb_release -a
  131. fi
  132. service tomcat start
  133. popd > /dev/null
  134. }